(	
global MTS_Rollout
	try (destroydialog MTS_Rollout)catch()
	
	local traceSetObj = undefined
	struct nfo (obj,name)
	local objInfo = undefined
	local nameArray = #()
	local objArray = #()
	local selArray = #()
	local selSetArray = #()
	local includeOn = undefined
	local targetIndex = undefined
	local targetIndexObj = undefined
	
	fn collectObjects = (
		for o in geometry collect (
		objInfo =  nfo obj:o name:o.name	
		append nameArray objInfo.name
		)
		for p in selection where (superClassOf p == GeometryClass) collect (
		targetIndex = findItem nameArray p.name
		deleteItem nameArray targetIndex
		)
	)
	
	collectObjects()
	

	
	rollout MTS_Rollout "MultiTraceSets"
(
	button 'btn1' "Add" pos:[10,295] width: 240 height: 40 align:#center tooltip: "This script edits the selected objects' reflection/refraction trace sets. Select a target object in the scene; choose which objects to exclude/include from the menu above and run."
	button 'btn2' "Clear" pos: [10,340] width: 100 height: 20 align:#center tooltip: "Clear the target objects' trace sets."
	button 'btn3' "Refresh" pos:[150,10] width: 100 height:20
	multilistbox 'lst1' "Scene Items:" pos:[10,20] width: 240 items: nameArray
	checkbox 'chk1' "Reflection" pos: [20,255] checked: false
	checkbox 'chk2' "Refraction" pos: [100,255] checked: false
	checkbox 'chk3' "Include?" pos: [180,255] checked: false
	checkbox 'setCheck' "Selection sets" pos:[20,200] checked: false
	
	groupBox 'group1' "Get objects from:" pos: [10, 180] width:240 height:50
	groupBox 'group2' "Trace Set Parameters:" pos: [10, 235] width:240 height:50
	
	label 'edt4' " Chaos 3D Support Team" pos:[120,345]
	hyperlink 'link1' "V-Ray Knowledge Base" pos:[140,360] color: (color 39 200 255) hovercolor: (color 39 140 255) address:"https://support.chaos.com/hc/en-us/sections/10633063984273-V-Ray-Knowledge-Base-"
	
	fn isVRayCurrent = matchPattern (renderers.current as string) pattern:"*V_RAY*"

	fn clearTraceSets = (
		for each in selection where (superClassOf each == GeometryClass) do (
		traceSetObj = vrayAddTraceSets each
		traceSetObj.reflect_exclude=#()
		traceSetObj.refract_exclude=#()
		traceSetObj.reflect_exclude_type=0
		traceSetObj.refract_exclude_type=0
		)
	)
	
	fn Refresh = (
		nameArray = #()
		objArray = #()
		lst1.items = #()
		collectObjects()
	)
	
	fn EditTraceSets = (
		if selection.count > 0 then (
		for each in selection where (superClassOf each == GeometryClass) do (
			
		traceSetObj = vrayAddTraceSets each
		if chk3.checked == true then traceSetObj.reflect_exclude_type=1 else traceSetObj.reflect_exclude_type=0
		if chk3.checked == true then traceSetObj.refract_exclude_type=1 else traceSetObj.refract_exclude_type=0
			
			if setCheck.checked == true then (
				for i in lst1.selection do (
					selSetArray = for each in selectionSets[i] collect each
					
					for p=1 to selSetArray.count do (
					if chk1.checked == true do (
					try(
					append traceSetObj.reflect_exclude selSetArray[p]
					traceSetObj.reflect_exclude = makeUniqueArray (traceSetObj.reflect_exclude as array)
					) catch (
						print ("Unable to add " + (selSetArray[p].name as string) + " to reflection exclude for " + (each.name as string) + ". Probably a dependency loop.")
						)
					)
					if chk2.checked ==true do (
					try(
					append traceSetObj.refract_exclude selSetArray[p]
					traceSetObj.refract_exclude = makeUniqueArray (traceSetObj.refract_exclude as array)
					) catch (
						print ("Unable to add " + (selSetArray[p].name as string) + " to refraction exclude for " + (each.name as string) + ". Probably a dependency loop.")
					)
					)
				)
			)
		)
			else (
				for o in geometry collect	
				(
				objInfo = nfo obj:o name:o.name
				append objArray objInfo.obj
				)
				for p in selection where (superClassOf p == GeometryClass) collect (
				targetIndexObj = findItem objArray p
				deleteItem objArray targetIndexObj
				)
				
				for i in lst1.selection do 
					(
					if chk1.checked == true do (
					try(
					append traceSetObj.reflect_exclude objArray[i]
					traceSetObj.reflect_exclude = makeUniqueArray (traceSetObj.reflect_exclude as array)
					) catch (
						print ("Unable to add " + (nameArray[i] as string) + " to reflection exclude for " + (each.name as string) + ". Probably a dependency loop.")
					)
				)
					if chk2.checked ==true do (
					try(
					append traceSetObj.refract_exclude objArray[i]
					traceSetObj.refract_exclude = makeUniqueArray (traceSetObj.refract_exclude as array)
					) catch (
					 print ("Unable to add " + (nameArray[i] as string) + " to refraction exclude for " + (each.name as string) + ". Probably a dependency loop.")
					)
				)
				)
			)
		)
	)
	else return messageBox "Select target object/s." title: "Error!"
	)
	
	on setCheck changed state do (
		case state of (
		true: (
			setNames = for i in SelectionSets collect i.name
			lst1.items =  setNames
		)
		false: (
			Refresh()
			lst1.items = makeUniqueArray nameArray
		)
	)
	)
		
	
	on btn1 pressed do 
	(
		if isVRayCurrent() == true then print "Okay." else return messageBox "V-Ray is not set to current renderer!" title: "Error!"
		if chk2.checked == false and chk1.checked == false do return messageBox "Choose trace set to add (reflection/refraction)." title: "Error!"
		clearTraceSets()
		EditTraceSets()
	)
	on btn2 pressed do (
		clearTraceSets()
	)
	on btn3 pressed do (
		if setCheck.checked == true then (
			Refresh()
			setNames = for i in SelectionSets collect i.name
			lst1.items = setNames
			)
			else (
			Refresh()
			lst1.items =  makeUniqueArray nameArray
			)
	)
)	
createDialog MTS_Rollout 260 385
)